<!DOCTYPE html>
<html xmlns:th="http://www.thymeleaf.org" th:replace="~{main-layout.html::main-fragment(~{::title},~{::#exemple-main-content})}">
<head>
    <meta charset="UTF-8">
    <title>Exemple</title>
</head>
<body>
    <div class="container-fluid" id="exemple-main-content">
        <h1>Exemple</h1>
        <h5><span class="badge text-bg-light mb-3 col-md-1" th:text="|compteur= ${cpt}|"></span></h5>
        <div class="alert alert-primary mb-2 col-md-6" th:if="${msg!=null}" th:text="${msg}">le message
        </div>
        <h4>Controleur</h4>
        <ul>
            <li><a class="my-2" th:href="@{/hello}">Helloworld</a></li>
            <li><a class="my-2" th:href="@{/exemple/testmodel}">Model</a></li>
            <li><a class="my-2" th:href="@{/exemple/testmodelandview}">ModelAndView</a></li>
        </ul>
        <h4>Request Mapping</h4>
        <ul>
            <li><a class="my-2" th:href="@{/exemple/testparams(id=12)}">url avec paramètre id=12</a></li>
            <li><a class="my-2 text-decoration-line-through" th:href="@{/exemple/testparamsv(id=3)}">url avec paramètre id=3 => erreur</a></li>
            <li><a class="my-2 text-decoration-line-through" th:href="@{/exemple/testparams}">url sans paramètre => erreur</a></li>
        </ul>
        <h4>Path Variable</h4>
        <ul>
            <li><a class="my-2" th:href="@{/exemple/testpath/2}">url /exemple/testpath/2</a></li>
            <li><a class="my-2" th:href="@{/exemple/testpathmulti/42/action/ajouter}">url/exemple/testpathmulti/42/action/ajouter</a></li>
            <li><a class="my-2" th:href="@{/exemple/testpathmap/42/action/ajouter}">url/exemple/testpathmap/42/action/ajouter</a></li>
            <li><a class="my-2" th:href="@{/exemple/testpathamb/42}">url avec /exemple/testpathamb/42</a></li>
            <li><a class="my-2" th:href="@{/exemple/testpathamb/smithee}">url avec /exemple/testpathamb/Smithee</a></li>
            <li><a class="my-2" th:href="@{/exemple/testpathoption}">url avec /exemple/testpathoption</a></li>
            <li><a class="my-2" th:href="@{/exemple/testpathoption/123}">url avec /exemple/testpathoption/123</a></li>
        </ul>
        <h4>RequestParam</h4>
        <ul>
            <li><a class="my-2" th:href="@{/exemple/testparam(id=23)}">test paramètre get id=23</a></li>
            <li><a class="my-2" th:href="@{/exemple/testparamdefault(id=56)}">test paramètre par défaut get id=56</a></li>
            <li><a class="my-2" th:href="@{/exemple/testparamdefault}">test paramètre par défaut</a></li>
            <li><a class="my-2" th:href="@{/exemple/testparamoption(id=42)}">test paramètre optionnel id=42</a></li>
            <li><a class="my-2" th:href="@{/exemple/testparamoption}">test paramètre optionnel</a></li>
            <li>
                <h5>RequestParam avec un Formulaire methode http: post</h5>
                <form method="post" th:action="@{/exemple/testformulaire}">
                    <label for="nom">Nom</label>
                    <input type="text" name="nom" id="nom" />
                    <input type="submit" value="confirmer" />
                </form>
            </li>
        </ul>
        <h4> En-tête de la requête</h4>
        <ul>
            <li><a class="my-2" th:href="@{/exemple/testheader}">request header: user-agent</a></li>
            <li><a class="my-2" th:href="@{/exemple/testallheader}">afficher toutes les en-tête de la requête</a></li>
        </ul>
        <ul class="list-group  list-group-flush">
            <li class="list-group-item" th:each="str : ${lstHeader}" th:text="${str}" />
        </ul>
        <h4>Lier les beans</h4>
        <ul>
            <li><a th:href="@{/exemple/testbindpath/1/john/doe}">Path: John Doe </a></li>
            <li><a th:href="@{/exemple/testbindparam(id=2,prenom=jane,nom=doe)}">Param: Jane Doe </a></li>
        </ul>
        <h4>Redirection et FlashAttribute</h4>
        <ul>
            <li><a class="my-2" th:href="@{/exemple/testredirect}">Test redirection(redirect) hello world</a></li>
            <li><a class="my-2" th:href="@{/exemple/testforward}">Test redirection(forward) hello world</a></li>
        </ul>
        <h4>Upload</h4>
        <form method="post" th:action="@{/exemple/upload}" enctype="multipart/form-data" >
            <label for="upload" class="form-label">Upload d'un fichier</label>
            <input type="file"  name="imgfile" id="upload"/>
            <input type="submit" class="btn btn-primary"/>
        </form>
        <h4>Email</h4>
        <ul>
          <li><a class="my-2" th:href="@{/exemple/simplemail}">Envoie de mail</a></li>
          <li><a class="my-2" th:href="@{/exemple/htmlmail}">Envoie de mail html</a></li>
          <li><a class="my-2" th:href="@{/exemple/templatemail}">Envoie de mail html thymeleaf</a></li>
        </ul>

        <h4>Internationalisation</h4>
        <div class="alert alert-info" th:text="#{name.training}"></div>
       
        <h4>Cookie</h4>
        <ul class="list-group list-group-flush" th:if="${cookies!=null}" >
            <li class="list-group-item" th:each="c : ${cookies}" th:text="${c}"/>
        </ul>
    </div>
</body>
</html>